////////////////////////////////////////////////////////////////////////////////////////////////////
// Experiment 13 - Default environment map fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifdef GL_FRAGMENT_PRECISION_HIGH
   // Default precision
   precision highp float;
#else
   precision mediump float;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// UNIFORM
uniform sampler2D   g_texture;
uniform samplerCube g_EnvironmentTexture2;
uniform vec3        g_vCamPos;

////////////////////////////////////////////////////////////////////////////////////////////////////
// VARYING
varying vec2	  vTexCoord;
varying vec3	  vColor;
varying vec3	  vWorldPos;
varying vec3	  vWorldNormal;
////////////////////////////////////////////////////////////////////////////////////////////////////

void main(void)
{

	vec4 vDiffuse = texture2D( g_texture, vTexCoord );
	vec3 vVertexToEye = normalize(g_vCamPos-vWorldPos);
	//vec3 vNormal = normalize(vWorldNormal + 0.4 * ( vDiffuse.rgb - vec3(0.5,0.5,0.5) ) );
	vec3 vNormal = normalize(vWorldNormal);
	vec3 vRefl = reflect( vVertexToEye, -vNormal );
	vec3 vEnv = textureCube( g_EnvironmentTexture2, vRefl ).rgb;
	
	//vec3 col = mix(vColor*vDiffuse.rgb, vEnv, 0.7 - vDiffuse.r );
	//vec3 col = mix(vColor*vDiffuse.rgb, vEnv, 0.3 );
	//gl_FragColor = vec4(col,vDiffuse.a);
	
	gl_FragColor = vec4(vColor*vDiffuse.rgb*0.9 + vEnv*0.3,vDiffuse.a);
}
