////////////////////////////////////////////////////////////////////////////////////////////////////
// Experiment 13 - Default fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifdef GL_FRAGMENT_PRECISION_HIGH
   // Default precision
   precision highp float;
#else
   precision mediump float;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// UNIFORM
uniform sampler2D   g_texture;
uniform vec4		g_vUser1;
////////////////////////////////////////////////////////////////////////////////////////////////////
// VARYING
varying vec2	  vTexCoord;
varying vec3	  vColor;
varying vec3	  vWorldPos;
varying vec3	  vWorldNormal;
////////////////////////////////////////////////////////////////////////////////////////////////////
void main(void)
{
	vec4 vDiffuse = texture2D( g_texture, vTexCoord );
	
	vec3 vShadow = ( g_vUser1.xyz - vWorldPos ) * 0.09; //0.12;
	float fShadow = dot( vShadow, vShadow );
	fShadow = 0.25 + ( min( fShadow, 1.0 ) ) * 0.75;
	fShadow = mix( fShadow, 1.0, ( 1.0 - max( dot( normalize( vShadow ), vWorldNormal), 0.0 ) ) );
	
	gl_FragColor = vec4(vColor*vDiffuse.rgb*fShadow,vDiffuse.a);
}
