////////////////////////////////////////////////////////////////////////////////////////////////////
//bloom post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform sampler2D g_texture2;
uniform vec3 g_fadeColor;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec4      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get samples
    vec4 vRT = texture2D( g_texture, uv_var.xy ) * 0.9;
    vec4 vBloom = texture2D( g_texture2, uv_var.xy );

    // Vignette
    vec2 uv = uv_var.xy - 0.5;
    vec3 fVignette = g_fadeColor * dot( uv, uv );

    // Add smooth and return
    gl_FragColor = (vRT+vBloom) - (vRT*vBloom) + vec4( fVignette.rgb, 0.0 );
}
