////////////////////////////////////////////////////////////////////////////////////////////////////
// Oasis - bloom soft post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform sampler2D g_texture2;

uniform vec4 g_lightColor;
uniform vec4 g_lightColor2;


////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;

////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get samples
    vec4 vRT = texture2D( g_texture, uv_var );
    vec4 vRT2 = texture2D( g_texture2, uv_var );
    
    vec2 uv = ( uv_var.xy - 0.5 ) * g_lightColor.a;
    float fVignette = min( dot( uv, uv ), 1.0 );
    
    vec3 vVigMul = mix( g_lightColor.rgb, g_lightColor2.rgb, fVignette );
    
    gl_FragColor = vec4((vRT.rgb * 0.65 + 0.30 * vRT2.rgb) * vVigMul,1.0);
    
    
    /*
    vec4 vBloom = texture2D( g_texture2, uv_var ) * 2.0;
    
    // Vignette
    vec2 uv = ( uv_var.xy - 0.5 ) * g_lightColor.a;
    float fVignette = min( dot( uv, uv ), 1.0 );
    
    vec3 vVigMul = mix( g_lightColor.rgb, g_lightColor2.rgb, fVignette );
   
    // Add smooth and return
    vec4 vComposited = (vRT+vBloom) - (vRT*vBloom);
    vComposited = min( vComposited, vec4( 1.0, 1.0, 1.0, 1.0 ) );
    
    gl_FragColor = vec4( 1.2 * vComposited.rgb * vVigMul.rgb, 1.0 );
    */
}
