////////////////////////////////////////////////////////////////////////////////////////////////////
// Downsample fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform vec2      g_screenPos;  // expected to contain ( 1.0 / screen_width, 1.0 / screen_height )



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    vec2 vSP0 = vec2( 0, -9.0 * g_screenPos.x );
    vec2 vSP1 = vec2( 0, -6.0 * g_screenPos.x );
    vec2 vSP2 = vec2( 0, -3.0 * g_screenPos.x );
    vec2 vSP3 = vec2( 0,  0.0 * g_screenPos.x );
    vec2 vSP4 = vec2( 0,  3.0 * g_screenPos.x );
    vec2 vSP5 = vec2( 0,  6.0 * g_screenPos.x );
    vec2 vSP6 = vec2( 0,  9.0 * g_screenPos.x );

//0.0366    0.1113    0.2167    0.2707    0.2167    0.1113    0.0366

    // Get samples
    vec4 vColor =  texture2D( g_texture, uv_var + vSP0 ) * 0.0366;
         vColor += texture2D( g_texture, uv_var + vSP1 ) * 0.1113;
         vColor += texture2D( g_texture, uv_var + vSP2 ) * 0.2167;
         vColor += texture2D( g_texture, uv_var + vSP3 ) * 0.2707;
         vColor += texture2D( g_texture, uv_var + vSP4 ) * 0.2167;
         vColor += texture2D( g_texture, uv_var + vSP5 ) * 0.1113;
         vColor += texture2D( g_texture, uv_var + vSP6 ) * 0.0366;

    // Average and return
    //gl_FragColor = vColor * 0.25;
    //gl_FragColor = vColor * 0.3;
    gl_FragColor = vColor;
}
