////////////////////////////////////////////////////////////////////////////////////////////////////
// Oasis - bloom soft post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D   g_texture;
uniform sampler2D   g_texture2;
uniform sampler2D   g_texture3;
uniform vec3        g_fadeColor;
uniform vec4        g_vUser1;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec4      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get samples
    vec4 vRT = texture2D( g_texture, uv_var.xy );
    
    vec4 vBloom = texture2D( g_texture2, uv_var.xy ) * 0.75;
    vBloom += texture2D( g_texture3, uv_var.xy ) * 0.55;
    vBloom *= g_vUser1.x;
    
    // Vignette
    vec2 uv = uv_var.xy - 0.5;
    vec3 fVignette = g_fadeColor * dot( uv, uv );

    // Add smooth and return
    vec4 vComposited = (vRT+vBloom) - (vRT*vBloom);
    gl_FragColor = vComposited*g_vUser1.y + vec4( fVignette.rgb, 0.0 );
}
