////////////////////////////////////////////////////////////////////////////////////////////////////
//bloom cutoff fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform vec2      g_screenPos;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{   
    vec2 vSP0 = vec2(  g_screenPos.x,  g_screenPos.y );
    vec2 vSP1 = vec2( -g_screenPos.x,  g_screenPos.y );
    vec2 vSP2 = vec2(  g_screenPos.x, -g_screenPos.y );
    vec2 vSP3 = vec2( -g_screenPos.x, -g_screenPos.y );    

    // Get samples
    vec4 vColor = texture2D( g_texture, uv_var + vSP0 );
    vColor += texture2D( g_texture, uv_var + vSP1 );
    vColor += texture2D( g_texture, uv_var + vSP2 );
    vColor += texture2D( g_texture, uv_var + vSP3 );

    // Average, cutoff and return
    vColor *= 0.25;
    vColor.rgb *= max( vColor.a, 0.1 );
    gl_FragColor = vColor;
}
