////////////////////////////////////////////////////////////////////////////////////////////////////
// Oasis - bloom cutoff soft fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform vec2      g_screenPos;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    vec2 vSP0 = vec2(  g_screenPos.x,  g_screenPos.y );
    vec2 vSP1 = vec2( -g_screenPos.x,  g_screenPos.y );
    vec2 vSP2 = vec2(  g_screenPos.x, -g_screenPos.y );
    vec2 vSP3 = vec2( -g_screenPos.x, -g_screenPos.y );    

    // Get samples
    vec4	vColor = texture2D( g_texture, uv_var + vSP0 );
			vColor += texture2D( g_texture, uv_var + vSP1 );
			vColor += texture2D( g_texture, uv_var + vSP2 );
			vColor += texture2D( g_texture, uv_var + vSP3 );

    // Average, cutoff and return
    vColor *= 0.25;
    
    //vColor.rgb = max( vColor.rgb - 0.275, 0.0 ) * 1.333;
    //vColor.rgb = max( vColor.rgb - 0.175, 0.0 ) * 1.333;
    //vColor.rgb = max( vColor.rgb - 0.075, 0.0 ) * 1.0;
    
    float lum = dot( vColor.rgb, vec3( 0.333, 0.334, 0.333 ) );
    lum = max( ((lum - 0.25) /*1.5*/ * 2.0)+0.25, 0.0 );
    lum = lum*lum;
    vColor.rgb *= lum;
    
    gl_FragColor = vColor;
}
