////////////////////////////////////////////////////////////////////////////////////////////////////
// radial blur cutoff post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform vec2      g_screenPos;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{   
    vec2 vSP0 = vec2(  g_screenPos.x,  g_screenPos.y );
    vec2 vSP1 = vec2( -g_screenPos.x,  g_screenPos.y );
    vec2 vSP2 = vec2(  g_screenPos.x, -g_screenPos.y );
    vec2 vSP3 = vec2( -g_screenPos.x, -g_screenPos.y );    

    // Get samples
    vec4 vColor = texture2D( g_texture, uv_var + vSP0 );
    vColor += texture2D( g_texture, uv_var + vSP1 );
    vColor += texture2D( g_texture, uv_var + vSP2 );
    vColor += texture2D( g_texture, uv_var + vSP3 );

    // Average, cutoff and return
    vColor *= 0.25;
    float fLum = dot( vColor.rgb, vec3( 0.333, 0.333, 0.333 ) );
    vColor.rgb = vec3( fLum, fLum, fLum );
    vColor.rgb = max( vColor.rgb - 0.8, 0.0 ) * 10.0;
    gl_FragColor = vColor;
}
