////////////////////////////////////////////////////////////////////////////////////////////////////
//depth of field post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform sampler2D g_texture2;
uniform sampler2D g_texture3;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec4      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get offset
    vec2 vOffset = texture2D( g_texture3, uv_var.zw ).xy * 0.003 - 0.0015;

    // Get samples
    vec4 vColSharp = texture2D( g_texture, uv_var.xy );
    vec4 vColBlur = texture2D( g_texture2, uv_var.xy + vOffset*vColSharp.a );

    // Blend and return
    gl_FragColor = mix( vColSharp, vColBlur, vColSharp.a );
}
