////////////////////////////////////////////////////////////////////////////////////////////////////
//heat distortion post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform sampler2D g_texture2;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec4      col_var;
varying vec4      uv_var;
varying float     vfade;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    vec4 vDepth = texture2D( g_texture, uv_var.xy );
    vec4 vOffset = texture2D( g_texture2, uv_var.zw ) * 0.01 - 0.005;
    vec4 vTexture = texture2D( g_texture, uv_var.xy + vOffset.xy*vDepth.a*vfade );
    
    // Only pick samples that are further away
    gl_FragColor = (vDepth.a > vTexture.a) ? vDepth : vTexture;
}
