////////////////////////////////////////////////////////////////////////////////////////////////////
//heat distortion post processing vertex shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////////////////////////
uniform mat4 g_mTransform;
uniform vec4 g_modcol;
uniform vec4 g_params;



////////////////////////////////////////////////////////////////////////////////////////////////////
attribute vec3 pos_attr;
attribute vec4 col_attr;
attribute vec2 uv_attr;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec4 col_var;
varying vec4 uv_var;
varying float vfade;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
	gl_Position  = g_mTransform * vec4( pos_attr.xyz, 1.0 );
	col_var      = col_attr * g_modcol;
	uv_var       = vec4( uv_attr.xy, uv_attr.xy * vec2( 0.5, 1.0 ) + g_params.xy );
	vfade        = 1.0 - ((gl_Position.y * 0.5 ) + 0.5);
}
