////////////////////////////////////////////////////////////////////////////////////////////////////
// Oasis - radial blur post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform vec3 g_fadeColor;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get samples
    vec4 vBlurColor = vec4( 1.0, 0.75, 0.5, 0.0 );
    vec4 vBlur = texture2D( g_texture, uv_var.xy );
    vBlur += texture2D( g_texture, (uv_var.xy*0.95) + 0.025 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.90) + 0.050 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.85) + 0.075 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.80) + 0.100 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.75) + 0.125 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.70) + 0.150 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.65) + 0.175 );
    vBlur += texture2D( g_texture, (uv_var.xy*0.60) + 0.200 );
    
    // Scale and return
    gl_FragColor = min( vBlur * vBlurColor * 0.25, 1.0 );
}
