////////////////////////////////////////////////////////////////////////////////////////////////////
// Oasis - radial blur composite post processing fragment shader
// 
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifndef NO_PRECISION_DEFINITION
	#ifdef GL_FRAGMENT_PRECISION_HIGH
	   precision highp float;
	#else
	   precision mediump float;
	#endif
#endif




////////////////////////////////////////////////////////////////////////////////////////////////////
uniform sampler2D g_texture;
uniform sampler2D g_texture2;
uniform vec3 g_fadeColor;



////////////////////////////////////////////////////////////////////////////////////////////////////
varying vec2      uv_var;



////////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
    // Get samples
    vec4 vRT = min( texture2D( g_texture, uv_var.xy ) * 1.5, 1.0 );
    vec4 vBlur = texture2D( g_texture2, uv_var.xy );
   
    // Add smooth and return
    gl_FragColor = (vRT+vBlur) - (vRT*vBlur);
}
