////////////////////////////////////////////////////////////////////////////////////////////////////
// Experiment 13 - Skel fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifdef GL_FRAGMENT_PRECISION_HIGH
   // Default precision
   precision highp float;
#else
   precision mediump float;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// UNIFORM
uniform sampler2D   g_texture;

////////////////////////////////////////////////////////////////////////////////////////////////////
// VARYING
varying vec2	  vTexCoord;
varying vec3	  vColor;

////////////////////////////////////////////////////////////////////////////////////////////////////

void main(void)
{
	vec4 vDiffuse = texture2D( g_texture, vTexCoord );
	gl_FragColor = vec4(vColor*vDiffuse.rgb,vDiffuse.a);
}
