////////////////////////////////////////////////////////////////////////////////////////////////////
// Experiment 13 - Skel fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

// OpenGL ES require that precision is defined for a fragment shader
#ifdef GL_FRAGMENT_PRECISION_HIGH
   // Default precision
   precision highp float;
#else
   precision mediump float;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// UNIFORM
uniform sampler2D   g_texture;
uniform samplerCube g_EnvironmentTexture2;
uniform vec3        g_vCamPos;
//uniform vec3		g_vCamPos;
//uniform vec3		g_vOmniPos;
//uniform vec4		g_vOmniColor;
//uniform vec2		g_vOmniAtt;
//uniform vec3		g_vOmniPos2;
//uniform vec4		g_vOmniColor2;
//uniform vec2		g_vOmniAtt2;
//uniform vec3		g_vOmniPos3;
//uniform vec4		g_vOmniColor3;
//uniform vec2		g_vOmniAtt3;
//uniform vec3		g_vOmniPos4;
//uniform vec4		g_vOmniColor4;
//uniform vec2		g_vOmniAtt4;
//uniform vec4		g_modcol;
////////////////////////////////////////////////////////////////////////////////////////////////////
// VARYING
varying vec2	  vTexCoord;
varying vec3	  vColor;
varying vec3	  vWorldPos;
varying vec3	  vWorldNormal;
////////////////////////////////////////////////////////////////////////////////////////////////////
/*
vec3 calc_omni(vec3 norm, vec3 eye, vec3 vpos, vec3 lpos, vec3 lcol, vec2 att)
{
    vec3 ldir = lpos - vpos;
    float dist = length(ldir);
    ldir = ldir / dist;
    
    float intensity = clamp( ( att.y - dist ) * att.x, 0.0, 1.0);
    float diff = max( dot( ldir, norm ), 0.0 );
	float spec = pow( max( dot( normalize( ldir + eye ), norm ), 0.0 ), 80.0);
    
    return ( diff + spec ) * intensity * lcol;
}
*/
void main(void)
{

	vec4 vDiffuse = texture2D( g_texture, vTexCoord );
	vec3 vVertexToEye = normalize(g_vCamPos-vWorldPos);
	vec3 vNormal = normalize(vWorldNormal);
	vec3 vRefl = reflect( vVertexToEye, -vNormal );
	vec3 vEnv = textureCube( g_EnvironmentTexture2, vRefl ).rgb;
	
	gl_FragColor = vec4(vColor*vDiffuse.rgb + vEnv*0.25,vDiffuse.a);
	//gl_FragColor = vec4(vEnv,vDiffuse.a);
	//gl_FragColor = vDiffuse;

	/*
	vec3 vVertexToEye = normalize(g_vCamPos-vWorldPos);
	vec3 vNormal = normalize(vWorldNormal);

	vColor = vColor * 0.65;
	//vColor = vColor * 0.15;
	if(true) vColor += calc_omni(vNormal, vVertexToEye, vWorldPos, g_vOmniPos,  g_vOmniColor.rgb,  g_vOmniAtt );
	if(true) vColor += calc_omni(vNormal, vVertexToEye, vWorldPos, g_vOmniPos2, g_vOmniColor2.rgb, g_vOmniAtt2);
	if(true) vColor += calc_omni(vNormal, vVertexToEye, vWorldPos, g_vOmniPos3, g_vOmniColor3.rgb, g_vOmniAtt3);
	if(true) vColor += calc_omni(vNormal, vVertexToEye, vWorldPos, g_vOmniPos4, g_vOmniColor4.rgb, g_vOmniAtt4);

    vec4 vDiffuse = texture2D( g_texture, vTexCoord );
    gl_FragColor = vec4( vColor * vDiffuse.rgb, vDiffuse.a );
	*/    
}
